/******************************************************************/
/*                                                                */
/*              Plot the impulse response functions               */
/*                                                                */
/*                        Frank Schorfheide                       */
/*                                                                */
/******************************************************************/

/* filename: irfplot.g
** created:  09/27/01
*/
new;
library pgraph;
cls;

#include c:\projects\active\sunspots\gauss1\pathspec.g
#include c:\projects\active\sunspots\gauss1\sunspec.g

nirf  = 40;                /* number of impulse responses */
ti    = seqa(1,1,nirf);

/* Read Posterior Simulation Summary Files
*/
mhrun  = "0";

if mhrun $== "0";
   dataselstr = "0";
endif;

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m = readr(fhdraw,1);
irf_s = readr(fhdraw,1);
irf_hpd_l = readr(fhdraw,1);
irf_hpd_h = readr(fhdraw,1);

irf_m     = reshape(irf_m,12,40)';
irf_hpd_l = reshape(irf_hpd_l,12,40)';
irf_hpd_h = reshape(irf_hpd_h,12,40)';

titlestr = "Monetary Shock"  $|
           "Demand Shock" $|
           "Supply Shock" $|
           "Sunspot Shock";

ystr     = "Output" $|
           "Inflation" $|
           "Nom Interest";

rstr     = " / R1" $| " / R2";

shmult = 1 | 1 | 1 | -1;

r_ind = 1;
do until r_ind > 1;
/* iterate over regimes */
   
    graphset;
    begwind;
    margin(0,0,0.2,0.2);
    window(4,3,0);
    fonts("microb");
    _ptitlht = 0.4;
    _paxht = 0.4;
    _pnumht = 0.35;
    _pcolor =2 ;
    _pltype = {6 1 1};
    _protate = 0; 
    _plctrl = 0;
    _plwidth = 5.5;
    _psymsiz = 5;
    _plegstr = "Mean\00090% HPD(U)\00090% HPD(L)";

    sh_ind = 1;
    do until sh_ind > 4;
    /* iterate over shocks */
    
       y_ind = 1;
       do until y_ind > 3;
       /* iterate over endogenous variables */

          if sh_ind == 4;
             ytics(0,1.0,0.1,1);
          endif;

          title(titlestr[sh_ind]);
          ylabel(ystr[y_ind]);       
          xy(ti, shmult[sh_ind]*irf_m[.,12*(r_ind-1)+3*(sh_ind-1)+y_ind] 
                 ~ shmult[sh_ind]*irf_hpd_l[.,12*(r_ind-1)+3*(sh_ind-1)+y_ind] 
                 ~ shmult[sh_ind]*irf_hpd_h[.,12*(r_ind-1)+3*(sh_ind-1)+y_ind] );
          nextwind;
                 
          y_ind = y_ind+1;
       endo;
       
       sh_ind = sh_ind+1;
    endo;
    
    endwind;
    r_ind = r_ind+1;
endo;    
