/******************************************************************/
/*                                                                */
/*              Plot the impulse response functions               */
/*                                                                */
/*                        Frank Schorfheide                       */
/*                                                                */
/******************************************************************/

/* filename: irfplot.g
** created:  09/27/01
*/
new;
library pgraph;
cls;

#include c:\projects\active\sunspots\gauss1\pathspec.g
#include c:\projects\active\sunspots\gauss1\sunspec.g

nirf  = 20;                /* number of impulse responses */
ti    = seqa(1,1,nirf);

sh_ind = 3;

/* Read Posterior Simulation Summary Files
*/
mhrun  = "2";

if mhrun $== "0";
   dataselstr = "0";
endif;

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldrawall  =  (lpath $+ "\\m3111irs")
       $| (lpath $+ "\\m3112irs")
       $| (lpath $+ "\\m2114irs");


titlestr = "Pre-Volcker (Prior 1, Indet.)"  $|
           "Pre-Volcker (Prior 2, Indet.)" $|
           "Pre-Volcker (Determinacy)";

ystr     = "Output" $|
           "Inflation" $|
           "Nom Interest";

if sh_ind == 1;
   y_min = -0.25 | -1 | -0.2;
   y_max = 0.05  | 0.6 | 1;
   y_step = 0.05 | 0.1 | 0.1;
   y_div  = 0 | 0 | 0;
elseif sh_ind ==2;
   y_min = -0.1 | -1.5 | -1;
   y_max =  0.7 |  5.0 | 3.0;
   y_step = 0.1 | 0.5 | 0.5;
   y_div  = 0 | 0 | 0;
elseif sh_ind ==3;
   y_min =   0 |  -6 | -3;
   y_max =   1.5 |  1.5 | 1.5;
   y_step = 0.25 | 0.5 | 0.5;
   y_div  = 0 | 0 | 0;
endif;

shmult = 1 | 1 | 1 | -1;

    graphset;
    begwind;
    margin(0,0,0.2,0.2);
    window(3,3,0);
    fonts("microb");
    _ptitlht = 0.4;
    _paxht = 0.4;
    _pnumht = 0.35;
    _pcolor =2 ;
    _pltype = {6 1 1};
    _protate = 0; 
    _plctrl = 0;
    _plwidth = 5.5;
    _psymsiz = 5;
    _plegstr = "Mean\00090% HPD(U)\00090% HPD(L)";

    inp_ind = 1;
    do until inp_ind > 3;
    /* iterate over input files */

    ldraw = ldrawall[inp_ind];
    open fhdraw = ^ldraw for read;

    irf_m = readr(fhdraw,1);
    irf_s = readr(fhdraw,1);
    irf_hpd_l = readr(fhdraw,1);
    irf_hpd_h = readr(fhdraw,1);

    irf_m     = reshape(irf_m,12,nirf)';
    irf_hpd_l = reshape(irf_hpd_l,12,nirf)';
    irf_hpd_h = reshape(irf_hpd_h,12,nirf)';

    closeall fhdraw;
    
       y_ind = 1;
       do until y_ind > 3;
       /* iterate over endogenous variables */


          ytics(y_min[y_ind],y_max[y_ind],y_step[y_ind],y_div[y_ind]);  

          if y_ind == 2; 
             title(titlestr[inp_ind]);
          else;
             title(" ");
          endif;
          ylabel(ystr[y_ind]);       
          xy(ti, shmult[sh_ind]*irf_m[.,3*(sh_ind-1)+y_ind] 
                 ~ shmult[sh_ind]*irf_hpd_l[.,3*(sh_ind-1)+y_ind] 
                 ~ shmult[sh_ind]*irf_hpd_h[.,3*(sh_ind-1)+y_ind] );
          nextwind;
                 
          y_ind = y_ind+1;
       endo;
       
       inp_ind = inp_ind+1;
    endo;
    
    endwind;
