/*************************************************************************
**  Simulate the DSGE model 
**************************************************************************/

/* filename: sunsim.g
** created:  10/18/01
** Modifications:
**
*/
new;
library pgraph, user;
  _fcmptol = 1E-10;
/* dlibrary -a PszTgSen,PsdTgSen; */
#include c:\projects\active\sunspots\gauss1\pathspec.g
#include c:\projects\active\sunspots\gauss1\sunspec.g
#include c:\projects\active\sunspots\gauss1\sunmod.src
#include c:\projects\active\sunspots\gauss1\sunlh.src

cls;
   
/* Load model parameters
*/
load path = ^priopath cggpara[17,1] = "msim_par.out";
para      = cggpara[.,datasel-7];

/* solve the DSGE model
*/
{T1,TC,TEPS,TETA,RC} = dsgesolv(para,mspec);
nstate = cols(T1);

if (RC[1] == 1) AND (RC[2]==1);
   /* determinacy */
   retcode = 0;
   RR = TEPS ~ zeros(nstate,1);

elseif (RC[1] == 1) AND (RC[2]==0) ;
   /* indeterminacy */
   retcode = 1;
   RR = TEPS ~ TETA;

else;
   /* no equilibrium exists or 
      numerical problems */
   retcode = RC[1]-1;
   series_sim = zeros(Tsimtotal,3);
   goto eofsunsim;
      
endif;

QQ = createcov(para[10:17,1]);
QQchol = chol(QQ)';

DD = 0 | para[4] | para[4]+para[5];
/* DD      = zeros(3,1); */
ZZ      = zeros(3,nstate);
ZZ[1,1] = 1; 
ZZ[2,2] = 4; /* measured inflation is annualized */ 
ZZ[3,3] = 4; /* measured interest rates are annualized */

state_sim = zeros(nstate,1);
series_sim = zeros(Tsimtotal+Tsimburn,3);

t = 1;
do until t > (Tsimtotal+Tsimburn);
   
   state_sim       = T1*state_sim + RR*QQchol*rndn(4,1);
   series_sim[t,.] = (DD + ZZ*state_sim)';
   t = t+1;

endo;

series_sim = series_sim[Tsimburn+1:Tsimtotal+Tsimburn,.];

"Data Simulated Successfully";
"Parameter Choice:    " datasel-7;
"Model Specification: " mspec;
"Return Code:         " retcode;
"Parameters:          "; para;
"Mean of Data:        " meanc(series_sim)';
"StD of Data:         " stdc(series_sim)';
eofsunsim:
/********************************************************
** Save simulated data
*/

osimdata         = datapath $+ "\\" $+ lmodel $+ "sim" $+ dataselstr;
create fhsimdata = ^osimdata with SERIES, 3, 8;
wr               = writer(fhsimdata,series_sim);
closeall fhsimdata;   

"Data saved";
